	nolist
	include	"ti83plus.inc"
	list

	define _AbsCode
	segment _AbsCode
	extern FlashImage

;------------------------------------------------------------------
ComputerNumbers		equ		appBackUpScreen
PlayerNumbers		equ		appBackUpScreen+5
TotalNumbers		equ		appBackUpScreen+10
PlayerIndex			equ		appBackUpScreen+11
TotalCorrect		equ		appBackUpScreen+12
TotalInPosition		equ		appBackUpScreen+13
TotalGuesses		equ		appBackUpScreen+14

;------------------------------------------------------------------
; The APP Header

	db 080h, 00Fh
	db 000h, 000h, 000h, 000h
	db 080h, 012h
	db 001h, 004h
	db 080h, 021h
	db 001h
	db 080h, 031h
	db 001h
	db 080h, 048h
	; the app name
	db "Comp4", 020h, 020h, 020h		; 8 bytes, pad with spaces
	;
	db 080h, 081h
	db 001h
	db 080h, 090h
	db 003h, 026h, 009h, 004h
	db 00Dh, 0BBh, 0A8h, 0EFh
	db 002h, 00Dh, 040h, 0A1h, 06Bh, 099h, 0F6h, 059h, 0BCh, 067h
	db 0F5h, 085h, 09Ch, 009h, 06Ch, 00Fh, 0B4h, 003h, 09Bh, 0C9h
	db 003h, 032h, 02Ch, 0E0h, 003h, 020h, 0E3h, 02Ch, 0F4h, 02Dh
	db 073h, 0B4h, 027h, 0C4h, 0A0h, 072h, 054h, 0B9h, 0EAh, 07Ch
	db 03Bh, 0AAh, 016h, 0F6h, 077h, 083h, 07Ah, 0EEh, 01Ah, 0D4h
	db 042h, 04Ch, 06Bh, 08Bh, 013h, 01Fh, 0BBh, 093h, 08Bh, 0FCh
	db 019h, 01Ch, 03Ch, 0ECh, 04Dh, 0E5h, 075h
	db 080h, 07Fh
	db 000h, 000h, 000h, 000h
	db 000h, 000h, 000h, 000h
	db 000h, 000h, 000h, 000h
	db 000h, 000h, 000h, 000h
	db 000h, 000h, 000h, 000h

Startup:
		B_CALL		ClrLCDFull
		B_CALL		RunIndicOff
		B_CALL		DisableApd
		res			indicOnly, (IY+indicFlags)
		set			plotLoc, (IY+plotFlags)
		B_CALL		RandInit

		; splash screen
		ld			a, 1
		call		FlashImage

ShowFlash
		B_CALL		Random
		ei
		halt
		res			onInterrupt,(IY+onFlags)
		B_CALL		GetCSC
		and			a
		jr			z, ShowFlash
		jp			NewGame
;
;-----------------------------------------------
;
Main:
		call		GetInput

		cp			skDel				; Exit ?
		jr			z, ExitApp			; yes
		cp			skClear				; Clear ?
		jr			z, NewGame			; yes
		cp			skEnter				; Enter ?
		jr			nz, NumKey			; nope
		ld			a, (PlayerIndex)	; yes. must be at least 3
		cp			3					; numbers entered.
		jp			m, Main
		ld			a, (TotalNumbers)	; Is the TotalNumbers value
		cp			9					; set yet ?
		jr			nz, Main

		ld			a, (PlayerIndex)
		ld			(TotalNumbers), a
		call		ShowPick
		jr			CheckNumbers

ScanCodes
	DB	sk9, sk8, sk7, sk6, sk5, sk4, sk3, sk2, sk1, sk0
NumKey
		ld			hl, ScanCodes
		ld			bc, 10
		cpir
		jr			nz, Main
		ld			b, c
		ld			a, (PlayerIndex)
		ld			c, a
		ld			a, b
		ld			b, 0
		ld			hl, PlayerNumbers
		add			hl, bc
		ld			(hl), a
		ld			a, (PlayerIndex)
		inc			a
		ld			(PlayerIndex), a
		ld			hl, TotalNumbers
		cp			(hl)				; maybe 9 if total hasn't been set
		jr			z, CheckNumbers		; yes
		cp			5					; maximum allowed ?
		jr			nz, Main			; no
		ld			(TotalNumbers), a	; yes, force TotalNumbers to 5
		call		ShowPick
;
; !!!!!!!!
; here is where we check the numbers
; !!!!!!!!
;
CheckNumbers
		xor			a
		ld			(PlayerIndex), a
		ld			(TotalCorrect), a
		ld			(TotalInPosition), a
		ld			hl, TotalGuesses
		inc			(hl)
		call		ShowGuess
;
; total correct first
;
		ld			ix, TotalCorrect
		ld			de, PlayerNumbers
		ld			hl, ComputerNumbers

		ld			a, (TotalNumbers)	; outer loop
		ld			b, a				; for b = TotalNumbers, b != 0, b--
CN_TC1
		push		bc					; save b
		ld			a, (TotalNumbers)	; inner loop
		ld			b, a				; for b = TotalNumbers, b != 0, b--
		ld			a, (de)
CN_TC2
		cp			(hl)				; if a=(hl), Z is set
		jr			nz, CN_TC3
		inc			(ix+0)				; increment TotalCorrect
CN_TC3
		inc			hl
		djnz		CN_TC2				; repeat inner loop
		inc			de					; next player number
		ld			hl, ComputerNumbers
		pop			bc
		djnz		CN_TC1				; repeat outer loop
;
; total correct position
;
		ld			ix, TotalInPosition
		ld			de, PlayerNumbers
		ld			hl, ComputerNumbers
		ld			a, (TotalNumbers)
		ld			b, a
CN_TP1
		ld			a, (de)
		cp			a, (hl)
		jr			nz, CN_TP2
		inc			(ix+0)
CN_TP2
		inc			hl
		inc			de
		djnz		CN_TP1

		call		OffAll				; clear all rectangles

		; did we win ???
		ld			a, (TotalNumbers)
		ld			hl, TotalCorrect
		cp			(hl)
		jp			nz, ShowResults
		ld			hl, TotalInPosition
		cp			(hl)
		jp			nz, ShowResults

		; we won, do a flashy thing for a while

		call		OffAll
		ld			b, 16
FLASH_1
		push		bc
		ld			b, 25
		call		Delay
		call		InvertAll
		pop			bc
		djnz		FLASH_1

		jr			NewGame
;
; Show Results
;
ShowResults
		ld			a, (TotalCorrect)
		and			a
		jr			z, CN_SR1
		dec			a
		sla			a
		ld			b, a
		call		OnLED
CN_SR1
		ld			a, (TotalInPosition)
		and			a
		jp			z, Main
		dec			a
		sla			a
		inc			a
		ld			b, a
		call		OnLED
		jp			Main

;
; !!!!!!!!
; New Game
; !!!!!!!!
;
NewGame
		ld			hl, appBackUpScreen
		ld			bc, 768
		B_CALL		MemClear

		ld			a, 9
		ld			(TotalNumbers), a

		; get 5 random numbers
		ld			b, 5
		ld			hl, ComputerNumbers
NG_1
		push		bc
		push		hl
		B_CALL		Random				; get 0.0 < R < 1.0
		ld			a, 99h				; 9.9 in OP2
		B_CALL		OP2SetA
		B_CALL		FPMult				; OP1 * OP2
		ld			a, (OP1+2)
		srl			a
		srl			a
		srl			a
		srl			a
		pop			hl
		ld			(hl), a
		inc			hl
		pop			bc
		djnz		NG_1

		; main screen
		ld			a, 2
		call		FlashImage
		call		ShowPick

		jr			Main				; back to main

ExitApp:
		B_CALL		EnableApd
		ld			(IY+textFlags), 0
		B_CALL		ReloadAppEntryVecs
		B_JUMP		JForceCmdNoChar		; Exit the application

;---------------------------------------
OnLED
		bit			0, b
		jr			z, ON_1
		ld			l, 88
		ld			e, 93
		jr			ON_2
ON_1
		ld			l, 2
		ld			e, 7
ON_2
		srl			b
		inc			b
		ld			a, 57
ON_3
		sub			11
		djnz		ON_3

		ld			h, a
		add			5
		ld			d, a
		B_CALL		FillRect
		ret

;---------------------------------------
;
;	Clear all rectangles.
;
;	Start at 0,0 - 9,9
;	Increment by 11 down screen
;	Then do 86,0 - 95,9
;	Increment by 11 down screen

OffAll
		ld			hl, 0000h
		ld			de, 0909h
OA_1
		push		hl
		push		de
		B_CALL		DrawRectBorderClear
		pop			de
		pop			hl
		ld			a, 11
		add			a, h
		ld			h, a
		add			a, 9
		ld			d, a
		cp			a, 64
		jr			nz, OA_1

		ld			hl, 0056h
		ld			de, 095Fh
OA_2
		push		hl
		push		de
		B_CALL		DrawRectBorderClear
		pop			de
		pop			hl
		ld			a, 11
		add			a, h
		ld			h, a
		add			a, 9
		ld			d, a
		cp			a, 64
		jr			nz, OA_2

		ret

;---------------------------------------
;
;	Invert all rectangles.
;
;	Start at 2,2 - 7,7
;	Increment by 11 down screen
;	Then do 88,2 - 93,7
;	Increment by 11 down screen

InvertAll
		ld			hl, 0202h
		ld			de, 0707h
IA_1
		push		hl
		push		de
		B_CALL		InvertRect
		pop			de
		pop			hl
		ld			a, 11
		add			a, h
		ld			h, a
		add			a, 5
		ld			d, a
		cp			a, 62
		jr			nz, IA_1

		ld			hl, 0258h
		ld			de, 075Dh
IA_2
		push		hl
		push		de
		B_CALL		InvertRect
		pop			de
		pop			hl
		ld			a, 11
		add			a, h
		ld			h, a
		add			a, 5
		ld			d, a
		cp			a, 62
		jr			nz, IA_2
		ret

;---------------------------------------
GetInput
		ld			b, 50
		call		Delay
		and			a
		ret			nz
		ld			hl, 0258h
		ld			de, 075Dh
		B_CALL		InvertRect
		jr			GetInput

;---------------------------------------
; Delay for B interrupts
Delay
		ei
		halt
		res			onInterrupt,(IY+onFlags)
		B_CALL		GetCSC
		and			a
		ret			nz
		djnz		Delay
		ret

;---------------------------------------
ShowPick
		ld			hl, 7
		ld			(curRow), hl
		ld			hl, strPick
SP_1
		ld			a, (hl)
		and			a
		jr			z, SP_2
		B_CALL		PutC
		inc			hl
		jr			SP_1
SP_2
		ld			a, (TotalNumbers)
		cp			a, 9
		ret			z
		add			'0'
		B_CALL		PutC
		ret
strPick
	DB	"Pick:", 0

;---------------------------------------
ShowGuess
		ld			hl, 0B07h
		ld			(curRow), hl
		ld			h, 0
		ld			a, (TotalGuesses)
		ld			l, a
		B_CALL		DispHL
		ld			hl, 0B07h
		ld			(curRow), hl
		ld			a, 'G'
		B_CALL		PutC
		ld			a, ':'
		B_CALL		PutC
		ret
;---------------------------------------
;

end

